"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = tslib_1.__importStar(require("react"));
var focus_trap_1 = tslib_1.__importDefault(require("focus-trap"));
function useFocusElement(elementRef, showing, options) {
    if (options === void 0) { options = {}; }
    React.useEffect(function () {
        var trap;
        function focusElement() {
            if (!elementRef.current) {
                console.error("No element found to found");
                return;
            }
            trap = focus_trap_1.default(elementRef.current, tslib_1.__assign({ escapeDeactivates: false, clickOutsideDeactivates: true, fallbackFocus: '[tabindex="-1"]' }, options));
            trap.activate();
        }
        function focusTrigger() {
            if (!trap) {
                return;
            }
            trap.deactivate();
        }
        if (showing)
            focusElement();
        else
            focusTrigger();
    }, [showing]);
}
exports.useFocusElement = useFocusElement;
