"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/** @jsx jsx */
var core_1 = require("@emotion/core");
var React = tslib_1.__importStar(require("react"));
var Avatar_1 = require("../Avatar");
var faker_1 = tslib_1.__importDefault(require("faker"));
var react_1 = require("@storybook/react");
var ComboBox_1 = require("../ComboBox");
var Form_1 = require("../Form");
var Text_1 = require("../Text");
var List_1 = require("../List");
exports.ComboBoxStories = react_1.storiesOf("ComboBox", module)
    .add("basic", function () {
    return core_1.jsx(Example, null);
})
    .add("list item", function () { return core_1.jsx(CustomExample, null); });
var defaultEntries = new Array(100).fill(null).map(function () { return ({
    id: faker_1.default.random.uuid(),
    name: faker_1.default.name.firstName() + " " + faker_1.default.name.lastName(),
    image: faker_1.default.image.avatar()
}); });
function Example() {
    var _a = React.useState(defaultEntries), entries = _a[0], setEntries = _a[1];
    var _b = React.useState(""), query = _b[0], setQuery = _b[1];
    var toRender = !query
        ? []
        : entries
            .filter(function (entry) { return entry.name.toLowerCase().indexOf(query.toLowerCase()) > -1; })
            .slice(0, 10);
    return (core_1.jsx("div", { css: { margin: "3rem auto", width: "30rem" } },
        core_1.jsx(ComboBox_1.ComboBox, { query: query, onQueryChange: function (v) {
                setQuery(v);
            }, onSelect: function (v) {
                setQuery(v);
            } },
            core_1.jsx(ComboBox_1.ComboBoxInput, { "aria-label": "Query users", placeholder: "Search for users", component: Form_1.InputBase, autocomplete: true }),
            query && (core_1.jsx(ComboBox_1.ComboBoxList, { "aria-label": "Query users" }, toRender.length ? (toRender.map(function (entry) {
                return core_1.jsx(ComboBox_1.ComboBoxOption, { value: entry.name, key: entry.id });
            })) : (core_1.jsx("div", null,
                core_1.jsx(Text_1.Text, { muted: true, css: { display: "block", padding: "0.5rem 0.75rem" } }, query && toRender.length === 0 ? (core_1.jsx("span", null, "No entries found.")) : (core_1.jsx("span", null, "Try searching for users by email or name."))))))))));
}
function CustomExample() {
    var _a = React.useState(defaultEntries), entries = _a[0], setEntries = _a[1];
    var _b = React.useState(""), query = _b[0], setQuery = _b[1];
    var toRender = !query
        ? []
        : entries
            .filter(function (entry) { return entry.name.toLowerCase().indexOf(query.toLowerCase()) > -1; })
            .slice(0, 8);
    return (core_1.jsx("div", { css: { margin: "3rem auto", width: "30rem" } },
        core_1.jsx(ComboBox_1.ComboBox, { query: query, onQueryChange: function (v) {
                setQuery(v);
            }, onSelect: function (v) {
                setQuery(v);
            } },
            core_1.jsx(ComboBox_1.ComboBoxInput, { "aria-label": "Query users", placeholder: "Search for users", component: Form_1.InputBase, autocomplete: true }),
            query && (core_1.jsx(ComboBox_1.ComboBoxList, { "aria-label": "Query users" }, toRender.length ? (toRender.map(function (entry) {
                return (core_1.jsx(ComboBox_1.ComboBoxOption, { css: { padding: 0 }, value: entry.name, key: entry.id },
                    core_1.jsx(List_1.ListItem, { interactive: false, primary: core_1.jsx(ComboBox_1.ComboBoxOptionText, { value: entry.name }), contentBefore: core_1.jsx(Avatar_1.Avatar, { size: "sm", name: entry.name, src: entry.image }) })));
            })) : (core_1.jsx("div", null,
                core_1.jsx(Text_1.Text, { muted: true, css: { display: "block", padding: "0.5rem 0.75rem" } }, query && toRender.length === 0 ? (core_1.jsx("span", null, "No entries found.")) : (core_1.jsx("span", null, "Try searching for users by email or name."))))))))));
}
